package fr.bhprod.sga.config;

import java.util.HashSet;
import java.util.Hashtable;

import com.jme.util.Timer;

import fr.bhprod.sga.entity.IMovable;
import fr.bhprod.sga.entity.PlayableObject;
import fr.bhprod.sga.entity.UnitObject;

/**
 * Contains the state of the game (mouse, keyboard, ...).
 * @author jbeaufils
 * @version 1.0
 */

public class GameState {
	public static String TYPE_OBJECT = "OBJECT";
	public static String TYPE_UNIT = "UNIT";
	
	private boolean clickLeft = false;
	private boolean clickRight = false;
	private boolean clickMiddle = false;
	private HashSet<String> keys = new HashSet<String>();
	private Hashtable<String,String> selectedObjects = new Hashtable<String,String>();
	private HashSet<IMovable> movableObjects = new HashSet<IMovable>();
	private Hashtable<String,PlayableObject> objects = new Hashtable<String,PlayableObject>();
	private Hashtable<String,UnitObject> units = new Hashtable<String,UnitObject>();
	private Timer timer = null;
	
	public GameState(Timer pTimer) {
		timer = pTimer;
	}

	public Hashtable<String, String> getSelectedObjects() {
		return selectedObjects;
	}

	public void setSelectedObjects(Hashtable<String, String> selectedObjects) {
		this.selectedObjects = selectedObjects;
	}

	public Hashtable<String, PlayableObject> getObjects() {
		return objects;
	}

	public void setObjects(Hashtable<String, PlayableObject> objects) {
		this.objects = objects;
	}

	public Hashtable<String, UnitObject> getUnits() {
		return units;
	}

	public void setUnits(Hashtable<String, UnitObject> units) {
		this.units = units;
	}

	public void refresh() {
		clickLeft = false;
		clickRight = false;
		clickMiddle = false;
		keys.clear();
	}
	
	public boolean isClickLeft() {
		return clickLeft;
	}
	public void setClickLeft(boolean clickLeft) {
		this.clickLeft = clickLeft;
	}
	public boolean isClickMiddle() {
		return clickMiddle;
	}
	public void setClickMiddle(boolean clickMiddle) {
		this.clickMiddle = clickMiddle;
	}
	public boolean isClickRight() {
		return clickRight;
	}
	public void setClickRight(boolean clickRight) {
		this.clickRight = clickRight;
	}

	public HashSet<String> getKeys() {
		return keys;
	}

	public HashSet<IMovable> getMovableObjects() {
		return movableObjects;
	}

	public void setMovableObjects(HashSet<IMovable> movableObjects) {
		this.movableObjects = movableObjects;
	}

	public Timer getTimer() {
		return timer;
	}

}

